<?php

/**
 * ImagetwistComHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImagetwistComHelper
 *
 * http://imagetwist.com/to995uhhnj8r/femjoy_10539066_124.jpg
 * page contains
 * http://img115.imagetwist.com/i/14430/to995uhhnj8r.jpg/femjoy_10539066_124.jpg
 * http://img115.imagetwist.com/i/14430/to995uhhnj8r.jpg/femjoy_10539066_124.jpg
 * 
 * <a href="http://imagetwist.com/q8qw97z855yy/ContactSheet.jpg" target="_blank"><img src="http://img115.imagetwist.com/th/14430/q8qw97z855yy.jpg" border="0" alt=""/></a>
 * http://imagetwist.com/q8qw97z855yy/ContactSheet.jpg
 * http://img115.imagetwist.com/th/14430/q8qw97z855yy.jpg
 * points to
 * http://img115.imagetwist.com/i/14430/q8qw97z855yy.jpg/ContactSheet.jpg
 *
 * <a href="http://imagetwist.com/to995uhhnj8r/femjoy_10539066_124.jpg" target="_blank"><img src="http://img115.imagetwist.com/th/14430/to995uhhnj8r.jpg" border="0" alt=""/></a>
 * points to
 * http://img115.imagetwist.com/i/14430/to995uhhnj8r.jpg/femjoy_10539066_124.jpg
 */
class ImagetwistComHelper extends BaseHelper
{

    /**
     * process
     * should receive something like:
     *  <a href="http://imagetwist.com/to995uhhnj8r/femjoy_10539066_124.jpg" target="_blank"><img src="http://img115.imagetwist.com/th/14430/to995uhhnj8r.jpg" border="0" alt=""/></a>
     * 
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $image['name'] = $this->getImageName($uri);
        if (!$image['name']) {
            return false;
        }
        $image_uri = $this->getImageUri($uri, $image['name']);
        $image['image'] = $this->getPage($image_uri);
        return $image;
    }

    /**
     * getImageName
     * image name can be found at the end of the a href.
     */
    public function getImageName($uri) {
        $href = return_between($uri, 'href="', '" target', EXCL);
        $parts = explode('/',$href);
        $name = array_pop($parts);
        return $name;
    }

    /**
     * getImageName
     * image name can be found at the end of the a href.
     * Based on this: 
     *   <a href="http://imagetwist.com/q8qw97z855yy/ContactSheet.jpg" target="_blank"><img src="http://img115.imagetwist.com/th/14430/q8qw97z855yy.jpg" border="0" alt=""/></a>
     * should get the following: 
     *   http://img115.imagetwist.com/i/14430/q8qw97z855yy.jpg/ContactSheet.jpg
     */
    public function getImageUri($uri, $name) {
        $href = return_between($uri, 'src="', '" border', EXCL);
        $href = str_replace("/th/", "/i/", $href);
        $href .= '/'.$name;
        return $href;
    }

    public function sendFullSnipet() {
        return true;
    }
}