<?php
/**
 * ImagezillaNetHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImagezillaNetHelper
 * this html for thumbnails
 * <a href="http://imagezilla.net/show/Wk5EWTa-aemelia_fox_side_view_.jpg" target="_blank"><img src="http://imagezilla.net/thumbs2/Wk5EWTa-aemelia_fox_side_view__tn.jpg" border="0" alt="" /></a>
 * points to
 * http://imagezilla.net/show/Wk5EWTa-aemelia_fox_side_view_.jpg
 * which has this html
 * <img id="photo" src="http://imagezilla.net/images/Wk5EWTa-aemelia_fox_side_view_.jpg" alt="Wk5EWTa-aemelia_fox_side_view_.jpg" title="Wk5EWTa-aemelia_fox_side_view_.jpg" border="0" />
 *
 * imagezilla.net is expecting the first href (http://imagezilla.net/show/Wk5EWTa-aemelia_fox_side_view_.jpg) as a REFERRER header for the image request
 */

class ImagezillaNetHelper extends BaseHelper
{

    public function process($uri) {
        //out($uri);
        $this->referrer = $uri;
        $page =  $this->getPage($uri);
        $image = $this->getImageInfo($page);
        $image['image'] = $this->getPageHtml($image['link']);
        return $image;
    }

    /**
     * looking for this img HTML
     * <img id="photo" src="http://imagezilla.net/images/Wk5EWTa-aemelia_fox_side_view_.jpg" alt="Wk5EWTa-aemelia_fox_side_view_.jpg" title="Wk5EWTa-aemelia_fox_side_view_.jpg" border="0" />
     * @param $page
     * @return bool
     */
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'http://imagezilla.net/images/')) {
                $retval['name'] = $this->getAttribute($image, 'alt');
                $retval['link'] = $this->getAttribute($image, 'src');
            }
        }
        return $retval;
    }
}