<?php

/**
 * ImgYtHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImgYtHelper
 *
 * https://img.yt/img-57cdd60505628.html
 * [post: continue to your image]
 * https://img.yt/upload/big/2016/09/05/57cdd605055ef.jpg
 *
 * https://img.yt/img-57cdd62842e0b.html
 * [post: continue to your image]
 * https://img.yt/upload/big/2016/09/05/57cdd62842dd3.jpg
 *
 * http://img.yt/img-57cdd5df5f9de.html
 * becomes
 * https://img.yt/img-57cdd5df5f9de.html
 * which points to:
 * https://img.yt/img-57cdd5df5f9de.html
 * which contains:
 * https://img.yt/upload/big/2016/09/05/57cdd5df5f9a6.jpg
 *
 * https://img.yt/img-582f56df5a5fb.html
 * https://img.yt/upload/big/2016/11/18/582f56df5a5bd.jpg
 *
 * looks like the form post needs to include imgContinue: "Continue+to+image+...+" as the POST param
 */
class ImgYtHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->postForm($uri);
//        $page = file_get_contents('test/detail.img.yt.html');
        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'] . '.jpg';
        $image['image'] = $this->getPage($info['link']);
        return $image;
    }

    public function postForm($uri) {
        $uri = str_replace('http:', 'https:', $uri);

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,$uri);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "imgContinue=Continue+to+image+...+");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec ($ch);

        curl_close ($ch);
        return $server_output;
    }

    /**
     * looking for this img HTML
     * <img class="centred" src="https://img.yt/upload/big/2016/11/18/582f564259d77.jpg" alt="cover2_642x642" style="max-width:1000px;">
     * @param $page
     * @return bool
     */
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'https://img.yt/upload/big')) {
                $retval['name'] = $this->getAttribute($image, 'alt');
                $retval['link'] = $this->getAttribute($image, 'src');
            }
        }
        return $retval;
    }
}