<?php

/**
 * this link:
 * https://imgbox.com/cen9h7nt
 * which contains HTML like this: 
 * <img alt="Xrlno5yf o" class="image-content" id="img" onclick="rs()" src="https://images3.imgbox.com/d7/54/xrlNo5Yf_o.jpg" title="MET-ART_rm_95_0000.jpg">
 * points to a page which has something like: 
 * https://images3.imgbox.com/f6/97/cen9h7nt_o.jpg?download=true
 */

/**
 * ImgboxComHelper.php
 *
 * @version $Id: $
 * @package ripper
 * @copyright 2019
 */
class ImgboxComHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->getPage($uri);
//        $page = file_get_contents('test/detail.imgbox.com.2.html');
        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'];
        $image['image'] = $this->getPage($info['link']);
        return $image;
    }
    
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'class="image-content"')) {
                $retval['name'] = $this->getAttribute($image, 'title');
                $retval['link'] = $this->getAttribute($image, 'src');
            }
        }
        return $retval;
    }
    
    /**
     * will receive something like: https://i.imgbox.com/YtnopzXN.jpg?download=true
     * return something like: http://imgbox.com/YtnopzXN
     * @param $uri
     */
    // public function makePageUri($uri) {
    //     $search = array('https://i.', '.jpg?download=true');
    //     $replace = array("http://", '');
    //     $temp = str_replace($search, $replace, $uri);
    //     return $temp;
    // }
    //
    // public function makeDownloadUri($uri) {
    //     //$expect = "https://i.imgbox.com/lAkZ4Mwd.jpg?download=true";
    //     $search = "http://";
    //     $replace = 'https://i.';
    //     $temp = str_replace($search, $replace, $uri);
    //     $new = $temp . '.jpg?download=true';
    //     return $new;
    // }
    //
    // public function getImageName($page) {
    //     $start = '<div class="image-container">';
    //     $end = '</div>';
    //     $string = return_between($page, $start, $end, EXCL);
    //     $title = return_between($string, 'title="', '"', EXCL);
    //     return $title;
    // }
    //
    // public function getImageSrc($page) {
    //     $start = '<div class="image-container">';
    //     $end = '</div>';
    //     $string = return_between($page, $start, $end, EXCL);
    //     $src = return_between($string, 'src="', '"', EXCL);
    //     return $src;
    // }
}