<?php

/**
 * ImgcandyNetHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImgcandyNetHelper
 *
 * http://imgcandy.net/img-5881226d468aa_1477830712KikiMotherTeresa-1.jpg.html
 * http://imgcandy.net/dlimg.php?id=5881226d468aa
 *
 */
class ImgcandyNetHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->postForm($uri);

        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'] . '.jpg';
        $image['image'] = $this->getPage($info['link']);
        return $image;
    }

    public function postForm($uri) {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,$uri);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "imgContinue=Continue+to+image+...+");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec ($ch);

        curl_close ($ch);
        return $server_output;
    }

    /**
     * <img class='centred' src='http://imgcandy.net/upload/big/2017/01/19/5881226d4686f.jpg' alt='1477830712KikiMotherTeresa-1' style='max-width:1000px;'/>
     * @param $page
     * @return bool
     */
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');

        foreach ($images as $image) {
            if (strstr($image, 'http://imgcandy.net/upload/big/')) {
                $retval['name'] = $this->getAttribute($image, 'alt');
                $retval['link'] = $this->getAttribute($image, 'src');
                continue;
            }
        }
        return $retval;
    }
}