<?php

/**
 * ImgsenSeHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImgsenSeHelper
 *
 * http://imgsen.se/img-56e6ed4f5201c.html
 * continue to image ...
 * http://imgsen.se/img-56e6ed4f5201c.html
 *
 */
class ImgsenSeHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->postForm($uri);

        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'] . '.jpg';
        $image['image'] = $this->getPage($info['link']);
        return $image;
    }

    public function postForm($uri) {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,$uri);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "imgContinue=Continue+to+image+...+");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec ($ch);

        curl_close ($ch);
        return $server_output;
    }

    /**
     * <img class='centred' src='http://imgsen.se/upload/big/2016/03/14/56e6ed4f51fe0.jpg' alt='TheLifeErotic-The-Designer-1-cover-clean' style='max-width:1000px;'/>
     * @param $page
     * @return bool
     */
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');

        foreach ($images as $image) {
            if (strstr($image, 'http://imgsen.se/upload/big/')) {
                $retval['name'] = $this->getAttribute($image, 'alt');
                $retval['link'] = $this->getAttribute($image, 'src');
                continue;
            }
        }
        return $retval;
    }
}