<?php

/**
 * ImgspiceComHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImgspiceComHelper
 *
 * URI used on thumbnail: http://www.imgspice.com/96sqwk1qs8xq/0.jpg.html
 * Ends up at: https://www.imgspice.com/96sqwk1qs8xq/0.jpg.html
 *
 * with: https://img51.imgspice.com/i/02803/96sqwk1qs8xq.jpg
 */

class ImgspiceComHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->getPage($uri);
//        $page = $this->getPage('test/detail.imgspice.com.html');
        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'];
        $image['image'] = $this->getPage($info['link']);
        return $image;
    }
    
    public function getImageInfo($html) {
        $images = parse_array($html, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'id="imgpreview"')) {
                $retval['link'] = $this->getAttribute($image, 'src');
                $retval['name'] = $this->getAttribute($image, 'alt');
            }
        }
        return $retval;
    }
    
}
