<?php

/**
 * ImgurComHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class ImgurComHelper
 *
 * 
 * 
 * 
 *
 * 
 */
class ImgurComHelper extends BaseHelper
{

    /**
     * createImageArray
     * we start with something like: 
     * {"hash":"IjSgwK1","title":"","description":null,"has_sound":false,"width":1062,"height":1600,"size":185570,"ext":".jpg","animated":false,"prefer_video":false,"looping":false,"datetime":"2019-02-01 00:13:39"}
     * and need to return something like: 
     * https://i.imgur.com/IjSgwK1.jpg
     * @param $html the full HTML of the Imgur album page (like view source)
     * @return array Return array of URIs that point to the images
     */
    public function createImageArray($html) {
        $start = strpos($html, '"images":');
        $end = strpos($html, '}]}', $start);
        $chunk = substr($html, $start+11, ($end-$start)+2);
        $pieces = explode('},{', $chunk);
        foreach($pieces as $piece) {
            $array = $this->convertToArray($piece);
            $image['link'] = 'https://i.imgur.com/'. $array['hash'] . $array['ext'];
            if (empty($array['title'])) {
                $image['name'] = $array['hash'];
            } else {
                $image['name'] = $array['title'];
            }
            $retval[] = $image;
        }
        return $retval;
    }

    public function convertToArray($piece) {
        $piece = str_replace('"', '', $piece);
        $parts = explode(',', $piece);
        foreach ($parts as $part) {
            $bits = explode(":", $part);
            $retval[$bits[0]] = $bits[1];
        }
        return $retval;
    }

    /**
     * process
     * @param $set and array of links to process
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($link) {
        $image['name'] = $link['name'] . '.jpg';
        $image['image'] = $this->getPage($link['link']);
        return $image;
    }

    /**
     * looking for this img HTML
     * <img class="centred" src="https://ima.gy/upload/big/2017/05/11/59140d97d8e91.jpg" alt="cover2_642x642" style="max-width:1000px;">
     * @param $page
     * @return bool
     */
    // public function getImageInfo($page) {
    //     $retval = false;
    //     $images = parse_array($page, '<img', '>');
    //     foreach ($images as $image) {
    //         if (strstr($image, 'https://ima.gy/upload/big')) {
    //             $retval['name'] = $this->getAttribute($image, 'alt');
    //             $retval['link'] = $this->getAttribute($image, 'src');
    //         }
    //     }
    //     return $retval;
    // }
}