<?php

/**
 * IronimgNetHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class IronimgNetHelper
 *
 * http://ironimg.net/yb5pxyc0ykxj/anya-ripped-and-ravishing-60-10000px.jpg
 * [post: continue to your image]
 * http://ironimg.net/i/010/00778/yb5pxyc0ykxj alt="anya-ripped-and-ravishing-60-10000px.jpg"
 *
 * looks like the form post needs to include imgContinue: "Continue+to+image+...+" as the POST param
 */
class IronimgNetHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->postForm($uri);
//        $page = file_get_contents('test/detail.ironimg.net.html');
        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'];
        $image['image'] = $this->getPage($info['link']);
        return $image;
    }

    /**
     * example HTML from page:
     * <Form method="POST" action=''>
    <input type="hidden" name="op" value="view">
    <input type="hidden" name="id" value="kpsfhjfj45qm">
    <input type="hidden" name="pre" value="1">
    <input type="submit" name="next" value="Continue to image...">
    </Form>
     * @param $uri
     * @return mixed
     */
    public function postForm($uri) {

        $info = parse_url($uri);

        $parts = explode('/', $info['path']);

        $id = $parts[1];
        $post = array('op'=>'view', 'id'=>$id, 'pre'=>'1', 'next'=>"Continue to image...");
        $post = http_build_query($post, '&');

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL,$uri);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $server_output = curl_exec ($ch);

        curl_close ($ch);
        return $server_output;
    }

    /**
     * looking for this img HTML
     * <img src="http://ironimg.net/i/010/00778/yb5pxyc0ykxj" class="pic" alt="anya-ripped-and-ravishing-60-10000px.jpg" onload="scaleImg(this)" style="-ms-interpolation-mode:bicubic" galleryimg="no">
     * @param $page
     * @return bool
     */
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'class="pic"')) {
                $retval['name'] = $this->getAttribute($image, 'alt');
                $retval['link'] = $this->getAttribute($image, 'src');
            }
        }
        return $retval;
    }
}