<?php

/**
 * PimpandhostComHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class PimpandhostComHelper
 *
 * the listing page has links like:
 * http://pimpandhost.com/image/85205265
 *
 * the detail page has this HTML that loads the image:
 * <img class="normal" src="http://ist5-1.filesor.com/pimpandhost.com/1/7/5/4/175437/5/L/v/M/5LvMt/img__011_l.jpg" />
 * 
 * in this case the image is: 
 * http://ist5-1.filesor.com/pimpandhost.com/1/7/5/4/175437/5/L/v/M/5LvMt/img__011_l.jpg
 * http://ist5-1.filesor.com/pimpandhost.com/1/7/5/4/175437/5/L/v/M/5LvMt/img__011.jpg
 */
class PimpandhostComHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->getPage($uri);
//        $page = file_get_contents('test/detail.pimpandhost.com.html');
        $info = $this->getImageInfo($page);
        $image['name'] = $info['name'] . '.jpg';
//out($info); exit;        
        $image['image'] = $this->getPage($info['link']);
        return $image;
    }

    /**
     * looking for this img HTML
     * <img class="normal" src="http://ist5-1.filesor.com/pimpandhost.com/1/7/5/4/175437/5/L/v/M/5LvMt/img__011_l.jpg" />
     * and need to change the URI slightly by removing the _l near the end.
     * @param $page
     * @return bool
     */
    public function getImageInfo($page) {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'class="normal"')) {
                $link = $this->getAttribute($image, 'src');
                $retval['link'] = str_replace('_l.jpg', '.jpg', $link);
                $pieces = explode('/', $retval['link']);
                $retval['name'] = array_pop($pieces);
            }
        }
        return $retval;
    }
}