<?php

/**
 * PixhostOrgHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2019
 */

/**
 * Class PixhostOrgHelper
 *
 * http://pixhost.org/show/7/22151357_115.jpg
 * https://img5.pixhost.org/images/7/22151357_115.jpg
 *
 * http://pixhost.org/show/6/22150781_014.jpg
 * https://img5.pixhost.org/images/6/22150781_014.jpg
 *
 * http://www.pixhost.org/show/3008/18860431_074.jpg
 * https://img4.pixhost.org/images/3008/18860431_074.jpg
 */
class PixhostOrgHelper extends BaseHelper
{

    /**
     * process
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->getPage($uri);
//        $page = $this->getPage('test/detail.pixhost.org.html');
        $image = $this->getImageInfo($page);
        $image['image'] = $this->getPage($image['uri']);
        return $image;
    }

    public function getImageInfo($page) {
        $images = parse_array($page, '<img id', '/>');
        $image['uri'] = get_attribute($images[0], 'src');
        $parts = explode('/',$image['uri']);
        $image['name'] = array_pop($parts);
        return $image;
    }

//    public function makeDownloadUri($uri) {
//        $search = array("http://www.", "show");
//        $replace = array('https://img5.', 'images');
//        $new = str_replace($search, $replace, $uri);
//        return $new;
//    }
}