<?php

/**
 * ViprImHelper.php
 *
 * @version $Id: $
 * @package Ripper
 * @copyright 2020
 */

/**
 * Class ViprImHelper
 *
 *
 */
class ViprImHelper extends BaseHelper
{

    /**
     * process
     * The listing in vipergirls looks like this:
     *  <a href="https://vipr.im/vjtbmf1cxm43" target="_blank" rel="nofollow"><img src="https://i7.vipr.im/th/00000/vjtbmf1cxm43.jpg" border="0" alt="" /></a>
     * The HTML page pointed to has the following:
     *  <img src="https://i7.vipr.im/i/00000/vjtbmf1cxm43.jpg/IMG_6642.jpg" class="pic img img-responsive" alt="IMG_6642.jpg" style="margin:0 auto;" />
     * The actual image is:
     *  https://i7.vipr.im/i/00000/vjtbmf1cxm43.jpg/IMG_6642.jpg
     *
     * @param $uri
     * @return array Return array with 'image' and 'name' as the keys
     */
    public function process($uri) {
        $page = $this->getPage($uri);
        $info = $this->getImageInfo($page);

        $image['name'] = $info['name'];

        if (!$image['name']) {
            return false;
        }

        $image['image'] = $this->getPage($info['link']);
        return $image;
    }

    public function getImageInfo($page)
    {
        $retval = false;
        $images = parse_array($page, '<img', '>');
        foreach ($images as $image) {
            if (strstr($image, 'class="pic img img-responsive"')) {
                $retval['name'] = $this->getAttribute($image, 'alt');
                $retval['link'] = $this->getAttribute($image, 'src');
            }
        }
        return $retval;
    }
    
    public function sendFullSnipet() {
        return true;
    }
}