<?php
/**
 * TerminalColors.php
 *
 * @version $Id: $
 * @package ripper
 * @copyright 2020
 */

class TerminalColors
{
    private $foreground_colors = array();
    private $background_colors = array();

    public function __construct() {
        $this->foreground_colors['black'] = '0;30';
        $this->foreground_colors['dark_gray'] = '1;30';
        $this->foreground_colors['blue'] = '0;34';
        $this->foreground_colors['light_blue'] = '1;34';
        $this->foreground_colors['green'] = '0;32';
        $this->foreground_colors['light_green'] = '1;32';
        $this->foreground_colors['cyan'] = '0;36';
        $this->foreground_colors['light_cyan'] = '1;36';
        $this->foreground_colors['red'] = '0;31';
        $this->foreground_colors['light_red'] = '1;31';
        $this->foreground_colors['purple'] = '0;35';
        $this->foreground_colors['light_purple'] = '1;35';
        $this->foreground_colors['brown'] = '0;33';
        $this->foreground_colors['yellow'] = '1;33';
        $this->foreground_colors['light_gray'] = '0;37';
        $this->foreground_colors['white'] = '1;37';

        $this->background_colors['black'] = '40';
        $this->background_colors['red'] = '41';
        $this->background_colors['green'] = '42';
        $this->background_colors['yellow'] = '43';
        $this->background_colors['blue'] = '44';
        $this->background_colors['magenta'] = '45';
        $this->background_colors['cyan'] = '46';
        $this->background_colors['light_gray'] = '47';
    }

    public function paint($string, $foreground_color = null, $background_color = null) {
        $colored_string = "";

        // Check if given foreground color found
        if (isset($this->foreground_colors[$foreground_color])) {
            $colored_string .= "\033[" . $this->foreground_colors[$foreground_color] . "m";
        }
        // Check if given background color found
        if (isset($this->background_colors[$background_color])) {
            $colored_string .= "\033[" . $this->background_colors[$background_color] . "m";
        }

        // Add string and end coloring
        $colored_string .=  $string . "\033[0m";

        return $colored_string;
    }

    // Returns all foreground color names
    public function getForegroundColors() {
        return array_keys($this->foreground_colors);
    }

    // Returns all background color names
    public function getBackgroundColors() {
        return array_keys($this->background_colors);
    }

    public function colorMap() {
        $map['foreground'] = [
            'default'=> '0',
            'black'=> '0;30',
            'red'=> '0;31',
            'green'=> '0;32',
            'yellow'=> '33',
            'blue'=> '34',
            'magenta'=> '35',
            'cyan'=> '36',
            'lightgray'=> '37',
            'darkgray'=> '90',
            'lightred'=> '91',
            'lightgreen'=> '92',
            'lightyellow'=> '93',
            'lightblue'=> '94',
            'lightmagenta'=> '95',
            'lightcyan'=> '96',
            'white'=> '97',
        ];
        $map['background'] = [
            'default'=> '49',
            'black'=> '40',
            'red'=> '41',
            'green'=> '42',
            'yellow'=> '43',
            'blue'=> '44',
            'magenta'=> '45',
            'cyan'=> '46',
            'lightgray'=> '47',
            'darkgray'=> '100',
            'lightred'=> '101',
            'lightgreen'=> '102',
            'lightyellow'=> '103',
            'lightblue'=> '104',
            'lightmagenta'=> '105',
            'lightcyan'=> '106',
            'white'=> '107',
        ];
        return $map;
    }
}