<?php
/**
* rip_post.php
*
* @version $Id: $
* @package Ripper
* @copyright 2020
*/

/**
 * The URI this time will look something like:
 * https://vipergirls.to/threads/5262129-Taylor-Nature-Queen-(May-06-2020)-82X?p=63695823&viewfull=1#post63695823
 * I need to extract the ?p=xxxxxxxxxx part
 *
 * @param $args
 * @param $rip
 */
function rip_post($args, $rip)
{
    verbose(__METHOD__ . ' - starting rip_post', $rip->getVerbose());
    $rs = $rip->loginToSite();
    if ($rs) {
        $logged_in = 'true';
    } else {
        $logged_in = 'false';
    }
    verbose(__METHOD__ . ' logged in is: ' . $logged_in, $rip->getVerbose());

    verbose(__METHOD__ . ' - grabbing page: ' . $args['uri'], $rip->getVerbose());

    $post_id = getPostId($args['uri']);

    /**
     * opts
     * is an array that can affect how the file is downloaded, not built yet though
     */
    $opts = null;
    $xmlstring = $rip->getDownloader()->getXml($rip->getDownloader()->getApiUri($args['uri'], $opts));
//    out($xmlstring);
    $xml = simplexml_load_string($xmlstring);

    $log = $rip->getConfigValue('log_downloads');
    $like = $rip->getConfigValue('auto_like');
    $clean = $rip->getConfigValue('clean_title');

    $post = getPostFromXml($xml, $post_id);
    if ($clean) {
        $title = getArgsTitle(cleanUpTitle($post['attributes']['title']));
    } else {
        $title = getArgsTitle($post['attributes']['title']);
    }

    if ($args['start'] !== 0) {
        $rip->setStart($args['start']);
    }

    $rip->makeImagesSaveToFolder($title);

    $rs = $rip->processXml($post['images']);
    if (!$rs) {
        $retval[] = $rip->getFails();
    }
    // log the download, if log_downloads is true
    if ($log) {
        $log_rs = $rip->db->insert([$title, $args['uri'], $rip->getProgressCounter()]);
    }
    // add a like to the post, if auto_like is true
    if ($like) {
        doLikeOfPost($post_id, $post['hash'], $rip->getDownloader());
    }

    $retval[] = $rs;

}

function getPostId($uri) {
    $parts = parse_url($uri);
    $query = $parts['query'];
    $search = ['p=', '&viewfull=1'];
    $replace = '';
    return str_replace($search, $replace, $query);
}
