<?php
/**
 * rip_tests.php
 *
 * @version $Id: $
 * @package ${NAMESPACE}
 * @copyright 2020
 */

/**
 * this function allows the user to run any of the tests for laxaeripper
 * should be able to select specific tests, or run a suite
 *
 * @param $args
 * @param $rip
 */

require_once 'DirectoryReader.php';

function rip_tests($args, $rip) {
    echo_color('Laxaeripper test suite'.PHP_EOL, 'green', 'white');
    //echo PHP_EOL;

    $args['verbose'] == true;
    verbose('starting config', $args['verbose']);
    $tests = getAvailableTests();
    $selection = getArgsTests($tests);
    $rs = convertInputToArrayOfTests($selection, $tests);
    foreach ($rs as $test) {
        $result[] = runTest($test);
    }
out($result); exit;
    return $rs;
}

function convertInputToArrayOfTests($selection, $tests) {
    verbose('convertInputToArrayOfTests',true);
    if ($selection === 'x') {
        return $tests;
    }
    $pos = strpos($selection, ',');
    if($pos !== false) {
        $pieces = explode(',', $selection);
        foreach ($pieces as $piece) {
            $retval[] = $tests[trim($piece)];
        }
    } else {
        $retval[] = $tests[$selection];
    }
    return $retval;
}

/**
 * tests are located in the test folder, prefaced with 'test_'
 */
function getAvailableTests() {
    verbose('getAvailableTests',true);
    $path = 'test/';
    $dir = new DirectoryReader();
    $list = $dir->getContents($path);
    if (!$list) {
        displayError('No tests to run');
    }
    foreach ($list as $item) {
        $pos = strpos($item, 'test_');
        if ($pos !== false) {
            $retval[] = $item;
        }
    }
    return $retval;
}

function getArgsTests($tests) {
    verbose('getArgsTests',true);

    echo PHP_EOL;
    foreach ($tests as $key => $test) {
        echo '['. $key .'] '. $test .PHP_EOL;
    }
    echo '[x] run all tests';
    echo PHP_EOL;
    echo 'Specify which tests you want to run.  You can select multiple tests by separating them with a comma. '. PHP_EOL;
    echo 'Select test(s): ';
    $input = trim(fgets(STDIN));

    return $input;
}

function runTest($test) {
    verbose('runTest',true);
    require_once 'test/'. $test;
    $classname = str_replace('.php', '', $test);
    $tester = new $classname;
    $rs = $tester->run();
    return $rs;
}